"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var Foco = /** @class */ (function (_super) {
    __extends(Foco, _super);
    function Foco() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.clickCaptured = false;
        _this.focusCaptured = false;
        _this.handleDocumentClick = function (event) {
            if (!_this.clickCaptured && _this.props.onClickOutside) {
                _this.props.onClickOutside(event);
            }
            _this.clickCaptured = false;
        };
        _this.handleInnerClick = function () {
            _this.clickCaptured = true;
        };
        _this.handleDocumentFocus = function (event) {
            if (!_this.focusCaptured && _this.props.onFocusOutside) {
                _this.props.onFocusOutside(event);
            }
            _this.focusCaptured = false;
        };
        _this.handleInnerFocus = function () {
            _this.focusCaptured = true;
        };
        return _this;
    }
    Foco.prototype.componentDidMount = function () {
        this.initDOMListeners();
    };
    Foco.prototype.componentWillUnmount = function () {
        this.removeDOMListeners();
    };
    Foco.prototype.render = function () {
        return (react_1.default.createElement("span", { className: this.props.className, style: this.props.style, onMouseDown: this.handleInnerClick, onFocus: this.handleInnerFocus, children: this.props.children, onTouchStart: this.handleInnerClick }));
    };
    Foco.prototype.initDOMListeners = function () {
        document.addEventListener('mousedown', this.handleDocumentClick);
        document.addEventListener('focus', this.handleDocumentFocus, true);
        document.addEventListener('touchstart', this.handleDocumentClick);
    };
    Foco.prototype.removeDOMListeners = function () {
        document.removeEventListener('mousedown', this.handleDocumentClick);
        document.removeEventListener('focus', this.handleDocumentFocus);
        document.removeEventListener('touchstart', this.handleDocumentClick);
    };
    return Foco;
}(react_1.default.Component));
exports.default = Foco;
